export const VULNERABILITY_CONFIG_HTML: string = `
<form #systemConfigFrom="ngForm" class="compact">
    <section class="form-block" style="margin-top:0px;margin-bottom:0px;">
        <label class="section-title">{{ 'CONFIG.SCANNING.TITLE' | translate }}</label>
        <div class="form-group">
            <label for="scanAllPolicy">{{ 'CONFIG.SCANNING.SCAN_ALL' | translate }}</label>
            <div class="select">
                <select id="scanAllPolicy" name="scanAllPolicy" [disabled]="!editable" [(ngModel)]="vulnerabilityConfig.scan_all_policy.value.type">
                    <option value="none">{{ 'CONFIG.SCANNING.NONE_POLICY' | translate }}</option>
                    <option value="daily">{{ 'CONFIG.SCANNING.DAILY_POLICY' | translate }}</option>
                    <option value="on_refresh">{{ 'CONFIG.SCANNING.REFRESH_POLICY' | translate }}</option>
                </select>
            </div>
            <input type="time" name="dailyTimePicker" [disabled]="!editable" [hidden]="!showTimePicker" [(ngModel)]="dailyTime" />
        </div>
        <div class="form-group form-group-override">
            <button class="btn btn-primary btn-sm" style="width:160px;" (click)="scanNow()">{{ 'CONFIG.SCANNING.SCAN_NOW' | translate }}</button>
        </div>
    </section>
</form>
`;

export const VULNERABILITY_CONFIG_STYLES: string = `
.form-group-override {
    padding-left: 0px !important;
}

.section-title {
    font-size: 14px !important;
    font-weight: 600 !important;
}
`;